<?php
/**
 *@(#)DefaultFormPainter.php - self describing
 *
 * @author	Daniel Brandauer
 */
include_once 'lib/FormPainter.php';
include_once 'lib/Form.php';
include_once 'lib/Util.php';

/**
 * DefaultFormPainter
 * This is used to generate form presentation code when no other painter is
 * specified.
 */
class DefaultFormPainter extends FormPainter
{
	/**
	 * sketch()
	 * Initializes the form code
	 */
	public function sketch($id = "contact")
	{
		$buffer = '';
		$buffer .= "<form id=\"$id\" name=\"$id\" action=\"\" method=\"post\">";
		$buffer .= '<table width="100%">';
		
		return $buffer;
	}
	
	/**
	 * paint()
	 * Does most important part of the code generation process--the content
	 */
	public function paint(&$field)
	{
		$buffer = '<tr>';        
		switch($field->type) {
			case 'multi':
			$buffer .= '<td colspan="2">';
			$buffer .= fstring($field->text, 'form-text');
			$buffer .= '</td>';
			$buffer .= '</tr><tr><td colspan="2">';
			$buffer .= '<textarea name="'.$field->id.'" id="'.$field->id.'" lines="7" cols="60" class="form-field">'.(($field->value!='')?$field->value:'').'</textarea>';
			$buffer .= '</td></tr>';
			break;
			
			case 'submit':
			$buffer .= '<td colspan="2">';
			$buffer .= '<input type="submit" name="'.$field->id.'" id="'.$field->id.'" value="'.$field->text.'" />';
			$buffer .= '</td></tr>';
			break;
			
			default:
			$buffer .= '<td>';
			$buffer .= fstring($field->text, 'form-text');
			$buffer .= '</td>';
			$buffer .= '<td>';
			$buffer .= '<input type="text" name="'.$field->id.'" id="'.$field->id.'"'.(($field->value!='')?(' value="'.$field->value.'"'):'').' />';
			$buffer .= '</td></tr>';
		}
		
		return $buffer;
	}
	
	/**
	 * gloss()
	 * Finalizes the form
	 */
	public function gloss()
	{
		$buffer = '';
		$buffer .= '</table>';
		$buffer .= '</form>';
		
		return $buffer;
	}
}
?>

