<?php //:noTabs=false:folding=explicit:tabSize=8:

/**
 * FormField
 * An abstraction for all form elements. Makes their dynamic creation much eaier
 * and much more consistent.
 */
class FormField
{
	/**
	 * $text
	 * The title or caption for the form field
	 */
	public $text = '';
	
	/**
	 * $type
	 * The type (needed for processing) of the form field. Some types
	 * (eg. 'email') require additional validation to be effective.
	 */
	public $type = 'text';
	
	/**
	 * $id
	 * The unique id for this field, used to extract it from the incoming
	 * data and to match it to its defenition for processing.
	 */
	public $id = '';
	
	/**
	 * $value
	 * The current (or default if used in defenition) value for the field.
	 */
	public $value = '';
	
	/**
	 * __construct()
	 * The constructor, makes object creation easier.
	 *
	 * @param	$text	The title or caption
	 * @param	$id	The unique identifier for current field
	 * @param	$type	The type of the field (for processing and display)
	 * @param	$value	The (default) value assigned to the field (optional)
	 */
	public function __construct($text, $id, $type, $value = '')
	{
		$this->text = $text;
		$this->id = $id;
		$this->type = $type;
		$this->valye = $value;
	}
}

?>

