<?php
include_once './Config.php';
include_once 'Data.php';
include_once 'PageManager.php';

function loadFile($path)
{
	$fp = fopen($path, 'r');
	$query = fread($fp, filesize($path));
	fclose($fp);
	
	return $query;
}

$data = new Data();
$pm = new PageManager();

print "<p>Creating Tables...";
$queryText = loadFile('./create_tables.sql');
$querys = explode(';', $queryText);
foreach($querys as $query) {
	$data->exec($query);
}
print "done</p>\n";

print "<p>Creating Initial Categories...";
$categoriesText = loadFile('./categories.txt');
$categories = explode("\n", $categoriesText);
foreach($categories as $category) {
	if($category != '') {
		$query = "insert into categories (category_name) values ('$category')";
		$data->exec($query);
	}
}
print "done</p>\n";

print "<p>Creating Initial Pages...<br />\n";
$pagesToLoad = scandir('./pages/en');
foreach($pagesToLoad as $pageToLoad) {
	if(preg_match('/\.page$/', $pageToLoad)) {
		$path = "./pages/en/$pageToLoad";
		$fp = fopen($path, 'r');
		$page = fread($fp, filesize($path));
		fclose($fp);
		
		list($category, $title, $ext) = explode('.', $pageToLoad);
		$id = str_replace(' ', '_', strtolower($title));
		$pm->createPage($id, $title, $category, $page, 'en');
		
		print "Added page: $title<br />\n";
	}
}

$pagesToLoad = scandir('./pages/es');
foreach($pagesToLoad as $pageToLoad) {
	if(preg_match('/\.page$/', $pageToLoad)) {
		$path = "./pages/es/$pageToLoad";
		$fp = fopen($path, 'r');
		$page = fread($fp, filesize($path));
		fclose($fp);
		
		list($category, $lid, $title, $ext) = explode('.', $pageToLoad);
		$id = str_replace(' ', '_', strtolower($lid));
		$pm->createPage($id, $title, $category, $page, 'es');
		
		print "Added page: $title<br />\n";
	}
}
print "done</p>\n";

print "<p>Loading Language Packs...";
$packsToLoad = scandir('./strings');
foreach($packsToLoad as $packToLoad) {
	if(preg_match('/\.txt$/', $packToLoad)) {
		$path = "./strings/$packToLoad";
		$fp = fopen($path, 'r');
		$pack = fread($fp, filesize($path));
		fclose($fp);
		
		list($lang, $ext) = explode('.', $packToLoad);
		
		$list = explode("\n", $pack);
		foreach($list as $item) {
			list($name, $value) = explode('=', $item);
			$query = "insert into strings (string_id,language,string)";
			$query .= " values('$name','$lang','$value')";
			$data->exec($query);
		}
	}
}
print "done</p>\n";

print "<p>Loading News Items...";
$newsToLoad = scandir('./news');
foreach($newsToLoad as $newsItem) {
	if(preg_match('/\.txt$/', $newsItem)) {
		$path = "./news/$newsItem";
		$fp = fopen($path, 'r');
		$newsContent = fread($fp, filesize($path));
		fclose($fp);
		
		list($newsTitle, $newsDate, $newsLang, $ext) = explode('.', $newsItem);
		
		$pm->createNewsItem($newsDate, $newsTitle, $newsContent, $newsLang);
	}
}
print "done</p>\n";

print "<p>Configuring Categories...";
$query = "update categories set";
$query .= " header_template='homepage/content.tpl'";
$query .= ", left_top_template='homepage/upper_left.tpl'";
$query .= ", left_bottom_template='homepage/lower_left.tpl'";
$query .= ", right_top_template='homepage/upper_right.tpl'";
$query .= ", right_bottom_template='homepage/lower_right.tpl'";
$query .= " where category_name='home'";
$data->exec($query);
print "done</p>\n";

print "<p>Configuring Modules...";
$modulesText = loadFile('./modules.txt');
$modulesList = explode("\n", $modulesText);
foreach($modulesList as $moduleLine) {
	list($mPage,$mCat,$mPath,$mType,$mRep) = explode(':',$moduleLine);
	if(!empty($mPath)) {
		$pm->createModule($mPage,$mCat,$mPath,$mType,$mRep);
	}
}
print "done</p>\n";

print "<p><b>Database has been set up successfully!</b></p>";
?>
